




<*+M2ADDTYPES   *>
<*+M2EXTENSIONS *>


MODULE HanoiGr;

  FROM IO      IMPORT WrLn, WrStr, WrCard, RdKey, RdCard;
  FROM Window  IMPORT WinType, WinDef, Color, SingleFrame, Open, Close, GotoXY, Clear;

  CONST
    MaxDisks = 11; (* Maximum Number of Disks, should be < 12 *)
  TYPE
    Tower = RECORD
              Top    : [0..MaxDisks];
              Needle : ARRAY [0..MaxDisks-1] OF CARDINAL;
            END;
    DispLine = ARRAY[0..22] OF CHAR;
  VAR
    Display : WinType;
    Towers  : ARRAY['A'..'C'] OF Tower;
    DispDisk: ARRAY[0..MaxDisks] OF DispLine;
    HPos    : ARRAY['A'..'C'] OF CARDINAL;
    Disks   : CARDINAL;
    move    : CARDINAL;
    Delay   : CARDINAL;
    Dummy   : CARDINAL;
    Ch      : CHAR;

  PROCEDURE Wait;

      VAR
        i,j : CARDINAL;
  BEGIN
       FOR i := 0 TO 50000 DO FOR j := 0 TO Delay DO  Dummy := j END END;
  END Wait;

  PROCEDURE TowersInit;
    VAR
      i : CARDINAL;
      W : WinDef;
  BEGIN
    (* Open a screen window *)
    WITH W DO
      X1 := 0; Y1 := 0; X2 := 79; Y2 := 24;
      Foreground := White;
      Background := Blue;
      CursorOn   := FALSE;
      WrapOn     := FALSE;
      Hidden     := FALSE;
      FrameOn    := TRUE;
      FrameDef   := SingleFrame;
      FrameFore  := Red;
      FrameBack  := Black;
    END;
    Display := Open( W );

    (* Get the demo parameters *)
    GotoXY(2,2);
    WrStr(" Welcome to the Towers of Hanoi demo "); WrLn; WrLn;
    WrStr(" Enter the number of disks (it should be less than 12) : "); Disks := RdCard(); WrLn;
    WrStr(" Enter the delay between moves (5000 is comfortable)   : "); Delay := RdCard(); WrLn;
    Clear;

    Towers['A'].Top := Disks;
    Towers['B'].Top := 0;
    Towers['C'].Top := 0;
    FOR i := 0 TO Disks-1 DO
      Towers['A'].Needle[i] := Disks-i
    END;


    HPos['A'] := 2;
    HPos['B'] := 26;
    HPos['C'] := 50;

    DispDisk[0] := "           |           ";
    DispDisk[1] := "          *|*          ";
    DispDisk[2] := "         **|**         ";
    DispDisk[3] := "        ***|***        ";
    DispDisk[4] := "       ****|****       ";
    DispDisk[5] := "      *****|*****      ";
    DispDisk[6] := "     ******|******     ";
    DispDisk[7] := "    *******|*******    ";
    DispDisk[8] := "   ********|********   ";
    DispDisk[9] := "  *********|*********  ";
    DispDisk[10]:= " **********|********** ";
    DispDisk[11]:= "***********|***********";

    FOR i := 0 TO Disks DO
      GotoXY(HPos['A'],22-i); WrStr(DispDisk[Disks-i]);
      GotoXY(HPos['B'],22-i); WrStr(DispDisk[0]);
      GotoXY(HPos['C'],22-i); WrStr(DispDisk[0]);
    END;
  END TowersInit;

  PROCEDURE MoveTower(Height:CARDINAL;From,Towards,Using:CHAR);

    PROCEDURE MoveDisk(TakeOff,PutOn:CHAR);
      VAR
        Disk : CARDINAL;
    BEGIN
      move := move + 1;
      WITH Towers[TakeOff] DO
        Top := Top - 1;
        Disk := Needle[Top];
        GotoXY(HPos[TakeOff],22-Top); WrStr(DispDisk[0]);
      END;
      WITH Towers[PutOn] DO
        Needle[Top] := Disk;
        GotoXY(HPos[PutOn],22-Top); WrStr(DispDisk[Disk]);
        Top := Top + 1;
      END;
      Wait;
    END MoveDisk;

  BEGIN
    IF Height > 0 THEN
      MoveTower(Height-1,From,Using,Towards);
      MoveDisk(From,Towards);
      MoveTower(Height-1,Using,Towards,From)
    END
  END MoveTower;

BEGIN
  TowersInit;
  move := 0;
  GotoXY(3,2);
  WrStr("Space bar to start ");
  Ch := RdKey();
  GotoXY(3,2);
  WrStr("                   ");
  MoveTower(Disks,'A','C','B');
  GotoXY(3,2);
  WrStr("It's done, Number of moves = ");
  WrCard(move,10); WrLn;
  WrStr("Space bar to terminate ");
  Ch := RdKey();
  Close(Display)
  
END HanoiGr.


