


<* + M2addtypes *>
<* + M2extensions *>


MODULE OptFreq;

(* Frequency synthetizer by means of backtracking *)

 FROM IO IMPORT WrLn, WrChar, WrStr, WrLngCard, WrCard, WrReal,RdKey;

CONST
    NFreq = 6;
    Tol = 0.1;

VAR
    Count : LONGCARD;
    NSol  : CARDINAL;
    MinCristal, MaxCristal, Cristal : REAL;
    MaxError : REAL;
    Ch : CHAR;

    Dividers    : ARRAY[1..NFreq] OF LONGCARD;
    Frequencies : ARRAY[1..NFreq] OF REAL;



    PROCEDURE Try(Freq : CARDINAL; MinRange, MaxRange : REAL);
      VAR
        Div, MinDiv, MaxDiv : LONGCARD;
	Frequency, Error, E : REAL;
	F : CARDINAL;

      PROCEDURE PrintSolution;
        VAR i : CARDINAL;
      BEGIN
        NSol := NSol + 1;
	IF (NSol MOD 10)=0 THEN Ch := RdKey() END;
	MaxError := Error;
        WrCard(NSol,5);
        WrStr(' Cr. = '); WrReal(Cristal,5,3);
	WrStr(' Err. = '); WrReal(Error,2,3);
        WrStr(' Div = ');
        FOR i := 1 TO NFreq DO WrLngCard(Dividers[i],5) END;
        WrLn;
      END PrintSolution;

    BEGIN
      Count := Count + 1;
      Frequency := Frequencies[Freq];
      MinDiv := TRUNC(MinRange/Frequency + 1.0);
      MaxDiv := TRUNC(MaxRange/Frequency);
      FOR Div := MinDiv TO MaxDiv DO
        Dividers[Freq] := Div;
	Cristal := 0.0;
	FOR F := 1 TO Freq DO
	  Cristal := Cristal + Frequencies[F]*FLOAT(Dividers[F])
	END;
	Cristal := Cristal / FLOAT(Freq);
	Error := 0.0;
	FOR F := 1 TO Freq DO
	  E :=  Frequencies[F] - Cristal/FLOAT(Dividers[F]);
	  Error := Error + E * E;
	END;
        IF Error < MaxError THEN
	  IF Freq = NFreq
	    THEN PrintSolution
            ELSE Try(Freq+1,FLOAT(Div) * (Frequency - Tol),FLOAT(Div) * (Frequency + Tol));
	  END
        END
      END
    END Try;

BEGIN
  Frequencies[1] := 875.0;
  Frequencies[2] := 1025.0;
  Frequencies[3] := 1475.0;
  Frequencies[4] := 1625.0;
  Frequencies[5] := 1925.0;
  Frequencies[6] := 2075.0;
  MinCristal := 1.0E6;
  MaxCristal := 10.0E6;
  MaxError := 6.0E-2;

  WrLn;WrLn;

  WrStr(' Recursive Frequencies synthetizer '); WrLn;

  (* Backtracking algorithm *)
  Try(1,MinCristal,MaxCristal);

  WrStr(' Procedure Try was called : ');
  WrLngCard (Count,10);
  WrStr(' times.'); WrLn;

END OptFreq.

