


<* + M2addtypes *>
<* + M2extensions *>


MODULE PlotTest1;

(* program to plot a sine wave *)

 FROM IO IMPORT WrLn, WrChar, WrStr, WrLngCard, WrCard, WrReal,RdKey;
 FROM MATHLIB IMPORT Sin, M_Pi;
 FROM Graph IMPORT Init, Plot, Rectangle, _clrLIGHTRED, _clrWHITE, _clrGREEN ;

 CONST
   Pi = M_Pi;
 TYPE
  RFunction = PROCEDURE(REAL):REAL;
 VAR
  Ch : CHAR;

    PROCEDURE SIN(x : REAL):REAL;
    BEGIN
     RETURN VAL(REAL,Sin(VAL(LONGREAL,x)))
    END SIN;



    PROCEDURE PlotRF(F : RFunction; First, Last, Min, Max : REAL;
                     NXPoints, NYPoints : CARDINAL);
     VAR
      x,y,z        : CARDINAL;
      YValue       : REAL;
      XStep, YStep : REAL;
    BEGIN
     IF Last > First THEN

      XStep := (Last-First)/FLOAT(NXPoints);
      YStep := (Max-Min)/FLOAT(NYPoints);

      IF Init(0,0,NXPoints,NYPoints) THEN
       FOR x := 0 TO NXPoints DO
        z := TRUNC((0.0 - Min)/YStep);
	Plot(x,z,_clrGREEN);
        YValue := (F(XStep*FLOAT(x)+First)-Min)/YStep;
	IF (YValue >= 0) AND (YValue <= FLOAT(NYPoints)) THEN
	 y := NYPoints - TRUNC(YValue);
	 Plot(x,y,_clrLIGHTRED)
	END  (* IF in plot range test *)
       END (* FOR *)
      END; (* IF Init *)
     END (* IF Last > First *)
    END PlotRF;		
BEGIN
 WrLn;
 WrStr('Program to plot the values of a real function '); WrLn;
 WrStr(' The plotted function is : SIN(x) '); WrLn;
 WrLn;
 PlotRF(SIN,0.0,3.0*Pi,-1.2,+1.2,500,500);
 Ch := RdKey();

END PlotTest1.

