<*+M2ADDTYPES   *>
<*+M2EXTENSIONS *>

MODULE Queensw;
  FROM Graph IMPORT Init, Plot, Rectangle, Disc, _clrBLACK, _clrWHITE, _clrMAGENTA;
  FROM IO IMPORT WrLn, WrChar, WrStr, WrLngCard, WrCard, RdKey, RdCard;

CONST Size = 50;   (* Size of a square, in points on the screen *)

VAR

    Board : ARRAY[-6..15],[1..8] OF BOOLEAN;
    r : [-6..15]; l : [1..8];
    NSol : CARDINAL;
    Ch : CHAR;
    Counter : LONGCARD; Delay : CARDINAL;


    PROCEDURE Wait;

      VAR
        i,j : CARDINAL;
    BEGIN
       FOR i := 1 TO Delay DO FOR j := 0 TO 65000 DO Counter := Counter + 1 END END;
    END Wait;

    PROCEDURE PlotBoard;
      VAR
        l,r: [1..8];
	
    BEGIN
      IF Init(1,1,Size*8,Size*8+25) THEN
        FOR l := 1 TO 8 DO
	  FOR r := 1 TO 8 DO
	    IF (r+l) MOD 2 = 0
	      THEN
	        Rectangle((r-1)*Size,(l-1)*Size,r*Size,l*Size,_clrBLACK,TRUE)
	      ELSE
	        Rectangle((r-1)*Size,(l-1)*Size,r*Size,l*Size,_clrWHITE,TRUE)
	    END  (* IF color square *)
	  END    (* FOR r *)
	END      (* FOR l *)
      END        (* IF successful initialisation graph library *)	
    END PlotBoard;

    PROCEDURE PutQueen(row,line : INTEGER);
    BEGIN
      Disc((row-1)*Size+Size DIV 2, (line-1)*Size+Size DIV 2 , Size DIV 4, _clrMAGENTA)
    END PutQueen;

    PROCEDURE EraseQueen(row,line : INTEGER);
    BEGIN
      IF (row+line) MOD 2 = 0
        THEN
	  Disc((row-1)*Size+Size DIV 2, (line-1)*Size+Size DIV 2 ,Size DIV 4, _clrBLACK)
        ELSE
	  Disc((row-1)*Size+Size DIV 2, (line-1)*Size+Size DIV 2 ,Size DIV 4, _clrWHITE)
      END  (* IF color square *)
    END EraseQueen;

    PROCEDURE PrintSolution;

    BEGIN
       NSol := NSol + 1;
       WrStr(' Solution Nr ');
       WrCard(NSol,4); WrLn;
       Ch := RdKey();
    END PrintSolution;

    PROCEDURE Try(line : CARDINAL);
      VAR row : CARDINAL;

      PROCEDURE Free(r,l:INTEGER):BOOLEAN;
        VAR i : INTEGER; f : BOOLEAN;
      BEGIN
        f := TRUE;
        FOR i := 1 TO l-1 DO
          f := f AND Board[r,i] AND Board[r+l-i,i] AND Board[r-l+i,i]
        END;
        RETURN f
      END Free;


    BEGIN
      FOR row := 1 TO 8 DO
        IF Free(row,line) THEN
          Board[row,line] := FALSE;
          PutQueen(row,line); Wait;
          IF line < 8 THEN Try(line + 1)
                      ELSE PrintSolution
          END;
          Board[row,line] := TRUE;
          EraseQueen(row,line); Wait;
        END;
      END
    END Try;

BEGIN
    WrLn; WrLn;
    WrStr(' Recursive Eight Queens Program ');
    WrLn;
    WrStr(' Please enter delay (between 0 and 100) ');
    Delay := RdCard();

    (* Board Initialisation *)
    FOR r := -6 TO 15 DO
      FOR l := 1 TO 8 DO
        Board[r,l] := TRUE;
      END
    END;
    NSol := 0;
    PlotBoard;
    Counter := 1;

    (* Backtracking algorithm *)
    Try(1);

(* Leave window open till any character is hit *)
    Ch := RdKey()

END Queensw.

