<*+M2ADDTYPES   *>
<*+M2EXTENSIONS *>
MODULE QUICK4;
 FROM Lib IMPORT RANDOM,GetTime;
 FROM IO IMPORT WrLn,WrCard,WrLngCard,WrStr,RdKey;

 CONST
    Size =  2000000;

 TYPE Item = RECORD key : CARDINAL END;
 VAR
    a : ARRAY [0..Size] OF Item;
    m : CARDINAL;
    i : LONGCARD;
    Hour, Min, Sec, HSec : CARDINAL;
    InitTime,EndTime,Time : LONGCARD;

 PROCEDURE Sort (VAR a:ARRAY OF Item; MinQuick: CARDINAL);
    PROCEDURE Exchange (i,j: LONGCARD);
       VAR
           t : Item;
       BEGIN
           t := a[i]; a[i] := a[j]; a[j] := t
       END Exchange;

    PROCEDURE InsSort (n:LONGCARD);
       (* Sorts a global ARRAY a[0,n], with element 0 unused. *)
       VAR
           x : Item;
           i,j : LONGCARD;
       BEGIN
           FOR i := 2 TO n DO
               x := a[i];
               a[0] := x;  (* sentinel *)
               j := i;
               WHILE x.key < a[j-1].key DO
                   a[j] := a[j-1];
                   j := j-1
               END;
               a[j] := x;
           END;
       END InsSort;

    PROCEDURE QuickSort (L,H:LONGCARD);
       VAR
           Pivot : CARDINAL;
           i,j:    LONGCARD;
    BEGIN
        i := L; j := H; Pivot := a[(L+H) DIV 2].key;
        REPEAT
            WHILE a[i].key < Pivot DO INC(i) END;
            WHILE a[j].key > Pivot DO DEC(j) END;
            IF i <= j THEN
                Exchange (i,j);
                INC (i); DEC(j)
            END;
        UNTIL i > j;
        IF j-L > MinQuick THEN QuickSort(L,j) END;
        IF H-i > MinQuick THEN QuickSort(i,H) END;
    END QuickSort;
BEGIN
    QuickSort(1,HIGH(a));
    InsSort(HIGH(a))
END Sort;

BEGIN

    WrLn; WrLn;
    WrStr('Sorting ');
    WrCard(Size,0);
    WrStr(' random numbers with Quick and Insertion sort '); WrLn; WrLn;
    FOR m := 1 TO 201 BY 5 DO

      FOR i := 1 TO Size DO
        a[i].key := RANDOM(20000)
      END;

      GetTime(Hour,Min,Sec,HSec);
      InitTime := VAL(LONGCARD,Hour)*360000
                + VAL(LONGCARD,Min)*6000
                + VAL(LONGCARD,Sec)*100
                + VAL(LONGCARD,HSec);
      Sort(a,m);
      GetTime(Hour,Min,Sec,HSec);
      EndTime  := VAL(LONGCARD,Hour)*360000
                + VAL(LONGCARD,Min)*6000
                + VAL(LONGCARD,Sec)*100
                + VAL(LONGCARD,HSec);
      Time := (EndTime - InitTime) * 10;
      WrStr('MinQuick = '); WrCard(m,3);
      WrStr('; Total time = ');
      WrLngCard (Time,10);
      WrStr(' miliseconds.'); WrLn;
    END;

END QUICK4.

